package de.ankri;

import java.net.InetAddress;
import java.util.Calendar;

import net.wimpi.modbus.io.ModbusTCPTransaction;
import net.wimpi.modbus.msg.ReadCoilsResponse;
import net.wimpi.modbus.msg.ReadInputDiscretesRequest;
import net.wimpi.modbus.msg.WriteMultipleRegistersRequest;
import net.wimpi.modbus.net.TCPMasterConnection;
import net.wimpi.modbus.procimg.Register;
import net.wimpi.modbus.procimg.SimpleRegister;

import org.bostonandroid.timepreference.TimePreference;

import android.content.Context;
import android.content.SharedPreferences;
import android.os.AsyncTask;
import android.os.Bundle;
import android.preference.PreferenceActivity;
import android.preference.PreferenceManager;
import android.support.v4.app.NavUtils;
import android.view.MenuItem;
import de.ankri.MainActivity.WriteRegisterParams;

public class TimePreferenceActivity extends PreferenceActivity implements SharedPreferences.OnSharedPreferenceChangeListener
{
	private Bundle savedInstanceState;
	InetAddress addr = null;
	TCPMasterConnection con = null;
	ModbusTCPTransaction trans = null;
	Register m1;
	Register m2;
	Register m3;
	int seconds;
	int hour;
	int status1;
	int minutes;
	SharedPreferences preferences;

	@Override
	public void onCreate(Bundle savedInstanceState)
	{

		preferences = this.getSharedPreferences("SwitchButtonDemo", 0);
		boolean isDark = preferences.getBoolean("isDark", false);
		if (isDark)
			this.setTheme(R.style.AppThemeDark);
		else
			this.setTheme(R.style.AppThemeLight);
		super.onCreate(savedInstanceState);
		getActionBar().setDisplayHomeAsUpEnabled(true);

		this.savedInstanceState = savedInstanceState;

		addPreferencesFromResource(R.xml.settings);

		PreferenceManager.getDefaultSharedPreferences(this).registerOnSharedPreferenceChangeListener(this);
		seconds = 0;

	}

	public boolean onOptionsItemSelected(MenuItem item)
	{
		switch (item.getItemId())
		{
		// Respond to the action bar's Up/Home button
			case android.R.id.home:
				NavUtils.navigateUpFromSameTask(this);
				return true;
		}
		return super.onOptionsItemSelected(item);
	}

	// This is used by the test.
	public Bundle getBundle()
	{
		return savedInstanceState;
	}

	// This is used by the test.
	public Calendar getCalendarOfAlert()
	{
		return TimePreference.getTimeFor(preferences(), "alert_at");
	}

	// This is used by the test.
	public Calendar getCalendarOfWaking()
	{
		return TimePreference.getTimeFor(preferences(), "wake_up");
	}

	private SharedPreferences preferences()
	{
		return PreferenceManager.getDefaultSharedPreferences(this);
	}

	@Override
	protected void onResume()
	{
		super.onResume();

		// SharedPreferences prefs = getPreferences(Context.MODE_PRIVATE);
		// getPreference("wake_up").setTime(prefs.getString("wake_up", TimePreference.defaultCalendarString()));
	}

	@Override
	protected void onPause()
	{
		super.onPause();

		SharedPreferences.Editor editor = getPreferences(Context.MODE_PRIVATE).edit();
		editor.putString("alert_at", TimePreference.formatter().format(getCalendarOfAlert().getTime()));
		editor.commit();
	}

	public void clearSharedPreferences()
	{
		SharedPreferences.Editor editor = getPreferences(Context.MODE_PRIVATE).edit();
		editor.clear();
		editor.commit();
	}

	public class write_register extends AsyncTask<WriteRegisterParams, String, Integer>
	{
		ReadInputDiscretesRequest req = null; // the request
		ReadCoilsResponse res = null; // the response

		int startReg;

		protected void onPreExecute()
		{
			try
			{
				// IP address;
				addr = InetAddress.getByName("192.168.16.254");
			}
			catch (Exception e)
			{
				// Log.d("MODBUS","IP error", e);

			}
		}

		protected Integer doInBackground(WriteRegisterParams... params)
		{

			try
			{

				con = new TCPMasterConnection(addr);
				con.setPort(8080);
				con.connect();
				if (con.isConnected())
				{

					System.out.println("Connected!");
				}

				try
				{

					int reference = params[0].reference;
					// Prepare the transaction
					seconds = 0;
					m1 = new SimpleRegister(hour);
					m2 = new SimpleRegister(minutes);
					m3 = new SimpleRegister(seconds);

					WriteMultipleRegistersRequest request1 = new WriteMultipleRegistersRequest(reference, new Register[] { m1, m2, m3 });

					request1.setUnitID(10);
					request1.setHeadless();
					trans = new ModbusTCPTransaction(con);
					trans.setRequest(request1);
					// trans.setRetries(2);
					System.out.println(request1.getHexMessage());
					trans.setConnection(con);

					// execute the transaction
					trans.execute();
					// get the response
					// res = (ReadCoilsResponse) trans.getResponse();
					// int new_in = ((ReadMultipleRegistersResponse) trans.getResponse()).getRegisterValue(0);
					// System.out.println("Response mine: " + new_in);
				}
				catch (Exception e)
				{
					// Log.d("MODBUS", "Error in reading/writing");
					return 1;
				}

			}
			catch (Exception e)
			{
				// Log.d("MODBUS","connection error", e);

				return 1;
			}
			return 0;
		}

		protected void onPostExecute(Integer bytes)
		{

			// System.out.println("Response: " + trans.getResponse().getHexMessage());

			if (con.isConnected())
			{

				// depurar.setText("conecta");
			}
			// text.setText("Digital Inputs Status=" + res.getDiscretes ().toString () );

		}
	}

	private TimePreference getPreference(String key)
	{
		return (TimePreference) getPreferenceManager().findPreference(key);
	}

	public void onSharedPreferenceChanged(SharedPreferences sharedPreferences, String key)
	{
		// TODO Auto-generated method stub
		// Enable / Disable timers for Relay 1
		if (key.equals("enabled_relay_1"))
		{

			// boolean state1 = preferences.getBoolean(key);
			SharedPreferences myPreference = PreferenceManager.getDefaultSharedPreferences(this);
			if (!myPreference.getBoolean("enabled_relay_1", false))
			{
				System.out.println("False");

				status1 = 0;
				int ref = 1999;
				WriteRegisterParams params1 = new WriteRegisterParams(ref);
				write_register_enabled regwrite1 = new write_register_enabled();
				regwrite1.execute(params1);
			}
			else if (myPreference.getBoolean("enabled_relay_1", true))
			{
				System.out.println("True");
				status1 = 1;
				int ref = 1999;
				WriteRegisterParams params1 = new WriteRegisterParams(ref);
				write_register_enabled regwrite1 = new write_register_enabled();
				regwrite1.execute(params1);
			}

		}
		// Enable / Disable timers for Relay 2
		if (key.equals("enabled_relay_2"))
		{

			// boolean state1 = preferences.getBoolean(key);
			SharedPreferences myPreference = PreferenceManager.getDefaultSharedPreferences(this);
			if (!myPreference.getBoolean("enabled_relay_2", false))
			{
				System.out.println("False");

				status1 = 0;
				int ref = 2000;
				WriteRegisterParams params1 = new WriteRegisterParams(ref);
				write_register_enabled regwrite1 = new write_register_enabled();
				regwrite1.execute(params1);
			}
			else if (myPreference.getBoolean("enabled_relay_2", true))
			{
				System.out.println("True");
				status1 = 1;
				int ref = 2000;
				WriteRegisterParams params1 = new WriteRegisterParams(ref);
				write_register_enabled regwrite1 = new write_register_enabled();
				regwrite1.execute(params1);
			}

		}

		// Enable / Disable timers for Relay 3
		if (key.equals("enabled_relay_3"))
		{

			// boolean state1 = preferences.getBoolean(key);
			SharedPreferences myPreference = PreferenceManager.getDefaultSharedPreferences(this);
			if (!myPreference.getBoolean("enabled_relay_3", false))
			{
				System.out.println("False");

				status1 = 0;
				int ref = 2001;
				WriteRegisterParams params1 = new WriteRegisterParams(ref);
				write_register_enabled regwrite1 = new write_register_enabled();
				regwrite1.execute(params1);
			}
			else if (myPreference.getBoolean("enabled_relay_3", true))
			{
				System.out.println("True");
				status1 = 1;
				int ref = 2001;
				WriteRegisterParams params1 = new WriteRegisterParams(ref);
				write_register_enabled regwrite1 = new write_register_enabled();
				regwrite1.execute(params1);
			}

		}
		// Enable / Disable timers for Relay 4
		if (key.equals("enabled_relay_4"))
		{

			// boolean state1 = preferences.getBoolean(key);
			SharedPreferences myPreference = PreferenceManager.getDefaultSharedPreferences(this);
			if (!myPreference.getBoolean("enabled_relay_4", false))
			{
				System.out.println("False");

				status1 = 0;
				int ref = 2002;
				WriteRegisterParams params1 = new WriteRegisterParams(ref);
				write_register_enabled regwrite1 = new write_register_enabled();
				regwrite1.execute(params1);
			}
			else if (myPreference.getBoolean("enabled_relay_4", true))
			{
				System.out.println("True");
				status1 = 1;
				int ref = 2002;
				WriteRegisterParams params1 = new WriteRegisterParams(ref);
				write_register_enabled regwrite1 = new write_register_enabled();
				regwrite1.execute(params1);
			}

		}

		// Enable / Disable timers for Relay 5
		if (key.equals("enabled_relay_5"))
		{

			// boolean state1 = preferences.getBoolean(key);
			SharedPreferences myPreference = PreferenceManager.getDefaultSharedPreferences(this);
			if (!myPreference.getBoolean("enabled_relay_5", false))
			{
				System.out.println("False");

				status1 = 0;
				int ref = 2003;
				WriteRegisterParams params1 = new WriteRegisterParams(ref);
				write_register_enabled regwrite1 = new write_register_enabled();
				regwrite1.execute(params1);
			}
			else if (myPreference.getBoolean("enabled_relay_5", true))
			{
				System.out.println("True");
				status1 = 1;
				int ref = 2003;
				WriteRegisterParams params1 = new WriteRegisterParams(ref);
				write_register_enabled regwrite1 = new write_register_enabled();
				regwrite1.execute(params1);
			}

		}

		if (key.equals("relay1_on"))
		{

			hour = TimePreference.getTimeFor(PreferenceManager.getDefaultSharedPreferences(this), "relay1_on").getTime().getHours();
			minutes = TimePreference.getTimeFor(PreferenceManager.getDefaultSharedPreferences(this), "relay1_on").getTime().getMinutes();

			int ref = 2004;
			WriteRegisterParams params1 = new WriteRegisterParams(ref);
			write_register regwrite1 = new write_register();
			regwrite1.execute(params1);
			preferences = this.getSharedPreferences("SwitchButtonDemo", 0);
			String lanSettings = preferences.getString("relay1_on", "12:22");
			System.out.println(lanSettings);
		}

		if (key.equals("relay1_off"))
		{
			hour = TimePreference.getTimeFor(PreferenceManager.getDefaultSharedPreferences(this), "relay1_off").getTime().getHours();
			minutes = TimePreference.getTimeFor(PreferenceManager.getDefaultSharedPreferences(this), "relay1_off").getTime().getMinutes();

			int ref = 2019;
			WriteRegisterParams params1 = new WriteRegisterParams(ref);
			write_register regwrite1 = new write_register();
			regwrite1.execute(params1);
		}

		if (key.equals("relay2_on"))
		{

			hour = TimePreference.getTimeFor(PreferenceManager.getDefaultSharedPreferences(this), "relay2_on").getTime().getHours();
			minutes = TimePreference.getTimeFor(PreferenceManager.getDefaultSharedPreferences(this), "relay2_on").getTime().getMinutes();

			int ref = 2007;
			WriteRegisterParams params1 = new WriteRegisterParams(ref);
			write_register regwrite1 = new write_register();
			regwrite1.execute(params1);
		}

		if (key.equals("relay2_off"))
		{

			hour = TimePreference.getTimeFor(PreferenceManager.getDefaultSharedPreferences(this), "relay2_off").getTime().getHours();
			minutes = TimePreference.getTimeFor(PreferenceManager.getDefaultSharedPreferences(this), "relay2_off").getTime().getMinutes();
			int ref = 2022;
			WriteRegisterParams params1 = new WriteRegisterParams(ref);
			write_register regwrite1 = new write_register();
			regwrite1.execute(params1);
		}

		if (key.equals("relay3_on"))
		{

			hour = TimePreference.getTimeFor(PreferenceManager.getDefaultSharedPreferences(this), "relay3_on").getTime().getHours();
			minutes = TimePreference.getTimeFor(PreferenceManager.getDefaultSharedPreferences(this), "relay3_on").getTime().getMinutes();

			int ref = 2010;
			WriteRegisterParams params1 = new WriteRegisterParams(ref);
			write_register regwrite1 = new write_register();
			regwrite1.execute(params1);
		}

		if (key.equals("relay3_off"))
		{

			hour = TimePreference.getTimeFor(PreferenceManager.getDefaultSharedPreferences(this), "relay3_off").getTime().getHours();
			minutes = TimePreference.getTimeFor(PreferenceManager.getDefaultSharedPreferences(this), "relay3_off").getTime().getMinutes();
			int ref = 2025;
			WriteRegisterParams params1 = new WriteRegisterParams(ref);
			write_register regwrite1 = new write_register();
			regwrite1.execute(params1);
		}

		if (key.equals("relay4_on"))
		{

			hour = TimePreference.getTimeFor(PreferenceManager.getDefaultSharedPreferences(this), "relay4_on").getTime().getHours();
			minutes = TimePreference.getTimeFor(PreferenceManager.getDefaultSharedPreferences(this), "relay4_on").getTime().getMinutes();

			int ref = 2013;
			WriteRegisterParams params1 = new WriteRegisterParams(ref);
			write_register regwrite1 = new write_register();
			regwrite1.execute(params1);
		}

		if (key.equals("relay4_off"))
		{

			hour = TimePreference.getTimeFor(PreferenceManager.getDefaultSharedPreferences(this), "relay4_off").getTime().getHours();
			minutes = TimePreference.getTimeFor(PreferenceManager.getDefaultSharedPreferences(this), "relay4_off").getTime().getMinutes();
			int ref = 2028;
			WriteRegisterParams params1 = new WriteRegisterParams(ref);
			write_register regwrite1 = new write_register();
			regwrite1.execute(params1);
		}

		if (key.equals("relay5_on"))
		{

			hour = TimePreference.getTimeFor(PreferenceManager.getDefaultSharedPreferences(this), "relay5_on").getTime().getHours();
			minutes = TimePreference.getTimeFor(PreferenceManager.getDefaultSharedPreferences(this), "relay5_on").getTime().getMinutes();

			int ref = 2016;
			WriteRegisterParams params1 = new WriteRegisterParams(ref);
			write_register regwrite1 = new write_register();
			regwrite1.execute(params1);
		}

		if (key.equals("relay5_off"))
		{

			hour = TimePreference.getTimeFor(PreferenceManager.getDefaultSharedPreferences(this), "relay5_off").getTime().getHours();
			minutes = TimePreference.getTimeFor(PreferenceManager.getDefaultSharedPreferences(this), "relay5_off").getTime().getMinutes();
			int ref = 2031;
			WriteRegisterParams params1 = new WriteRegisterParams(ref);
			write_register regwrite1 = new write_register();
			regwrite1.execute(params1);
		}

	}

	public class write_register_enabled extends AsyncTask<WriteRegisterParams, String, Integer>
	{
		ReadInputDiscretesRequest req = null; // the request
		ReadCoilsResponse res = null; // the response

		int startReg;

		protected void onPreExecute()
		{
			try
			{
				// IP address;
				addr = InetAddress.getByName("192.168.16.254");
			}
			catch (Exception e)
			{
				// Log.d("MODBUS","IP error", e);

			}
		}

		protected Integer doInBackground(WriteRegisterParams... params)
		{

			try
			{

				con = new TCPMasterConnection(addr);
				con.setPort(8080);
				con.connect();
				if (con.isConnected())
				{

					System.out.println("Connected!");
				}

				try
				{

					int reference = params[0].reference;
					// Prepare the transaction
					// m1 = new SimpleRegister(hour);
					// m2 = new SimpleRegister(minutes);
					m3 = new SimpleRegister(status1);
					WriteMultipleRegistersRequest request1 = new WriteMultipleRegistersRequest(reference, new Register[] { m3 });

					request1.setUnitID(10);
					request1.setHeadless();
					System.out.println(request1.getHexMessage());
					trans = new ModbusTCPTransaction(con);
					trans.setRequest(request1);
					// trans.setRetries(2);

					trans.setConnection(con);

					// execute the transaction
					trans.execute();
					// get the response
					// res = (ReadCoilsResponse) trans.getResponse();
					// int new_in = ((ReadMultipleRegistersResponse) trans.getResponse()).getRegisterValue(0);
					// System.out.println("Response mine: " + new_in);
				}
				catch (Exception e)
				{
					// Log.d("MODBUS", "Error in reading/writing");
					return 1;
				}

			}
			catch (Exception e)
			{
				// Log.d("MODBUS","connection error", e);

				return 1;
			}
			return 0;
		}

		protected void onPostExecute(Integer bytes)
		{

			// System.out.println("Response: " + trans.getResponse().getHexMessage());

			if (con.isConnected())
			{

				// depurar.setText("conecta");
			}
			// text.setText("Digital Inputs Status=" + res.getDiscretes ().toString () );

		}
	}
}
